/*
 * Task Manager is Copyright (C) 2009  Mars Telecom
 * Auther Mohammed Taqi Ahmed
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
#include "main.h"


#define filename "/tmp/.tess"
//#define filename "/home/taqi/TM/test"
#define LINES_SKIPPED 3

//#define PACKAGE "taskmanager"
//#define VERSION "0.1"

/* 
 * Global data - help for using iptables. 
 * variables to get table, chain and rule for deletion.
 */
typedef struct task
{
   gint pid;
   gchar pname[50];
   gchar uname[50];
   gint cpuused;
   gint size;
} TASKS;

TASKS sysTasks[200];

typedef struct {
  /* Underlining active for text? Either TRUE or FALSE. */
  gboolean styleUseUnderline;
  /* Currently selected slant for text. Either STYLE_SLANT_NORMAL or
   *      STYLE_SLANT_ITALIC. */
  gboolean styleSlant;
  /* The currently selected color. */
  GdkColor currentColor;
  /* We need to keep pointers to these two widgets so that we can
   *   control their visibility from callbacks. */
  GtkWidget* findToolbar;
  GtkWidget* mainToolbar;
  /* We'll also keep visibility flags for both of the toolbars.
   *
   *      You could also test widget-visibility like this:
   *           if (GTK_WIDGET_VISIBLE(widget)) { .. }; */
   gboolean findToolbarIsVisible;
   gboolean mainToolbarIsVisible;
   /* Pointer to our HildonProgram. */
   HildonProgram* program;
   /* Pointer to our main Window. */
   HildonWindow* window;
} ApplicationState;


/* Widgets used by the main window */
typedef struct _st_wnd
{
  ApplicationState aState;
  //GtkWidget *wnd_main;
  GtkWidget *bt_kill;
  GtkWidget *bt_exit;
  GtkWidget *bt_about;
  GtkWidget *frm_main;
  GtkWidget *bx_one;
  GtkWidget *bx_two;
  GtkWidget *bx_three;
  GtkWidget *cb_tables;
  GtkWidget *ls_rules;
  GtkWidget *scrolled_wnd_list;
  //GtkAdjustment* vAdjust;
} STWND;

static STWND main_wnd;

//ApplicationState aState = {};

static int want_to_exit()
{
  int n_res;

  /* ask first */
  n_res = message_box(HILDON_WINDOW(main_wnd.aState.window), "Would you like to exit?",
		      GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO);

  if (n_res != GTK_RESPONSE_YES)
    return FALSE;

  return TRUE;
}

static void create_kill_button()
{
  GtkWidget *img_label;

  main_wnd.bt_kill = gtk_button_new();
  gtk_signal_connect(GTK_OBJECT (main_wnd.bt_kill), "clicked",GTK_SIGNAL_FUNC (on_bt_kill_clicked), NULL);
/*  GdkColor couleur={0,65535,0,0};

  GtkStyle *style=gtk_style_copy(main_wnd.bt_kill->style);
  //here we set button color for all states possible
  ////bg stands for bgcolor
  style->bg[0] = couleur;
  style->bg[1] = couleur;
  style->bg[3] = couleur;
  style->bg[2] = couleur;
  style->bg[4] = couleur;
  gtk_widget_set_style (main_wnd.bt_kill, style);
  */                  
  gtk_box_pack_start(GTK_BOX (main_wnd.bx_two), main_wnd.bt_kill, 
		     FALSE, TRUE, 0);
  img_label = png_label_box(PIXMAPS_DIR"/trash.png", " Kill ");
  gtk_widget_show(img_label);
  gtk_container_add(GTK_CONTAINER (main_wnd.bt_kill), img_label);
  gtk_widget_show (main_wnd.bt_kill);
}

static void create_exit_button()
{
  GtkWidget *img_label;

  main_wnd.bt_exit = gtk_button_new();
  gtk_signal_connect(GTK_OBJECT (main_wnd.bt_exit), "clicked",
		     GTK_SIGNAL_FUNC (on_bt_exit_clicked), NULL);

  gtk_box_pack_start(GTK_BOX (main_wnd.bx_two), main_wnd.bt_exit, 
		     FALSE, TRUE, 0);
  img_label = png_label_box(PIXMAPS_DIR"/exit.png", " Exit ");
  gtk_widget_show(img_label);
  gtk_container_add(GTK_CONTAINER (main_wnd.bt_exit), img_label);
  gtk_widget_show (main_wnd.bt_exit);
}

static void create_about_button()
{
  GtkWidget *img_label;

  main_wnd.bt_about = gtk_button_new();
  gtk_signal_connect(GTK_OBJECT (main_wnd.bt_about), "clicked",
		     GTK_SIGNAL_FUNC (on_bt_about_clicked), NULL);

  gtk_box_pack_start(GTK_BOX (main_wnd.bx_two), main_wnd.bt_about, 
		     FALSE, TRUE, 0);
  img_label = png_label_box(PIXMAPS_DIR"/about.png", " About ");
  gtk_widget_show(img_label);
  gtk_container_add(GTK_CONTAINER (main_wnd.bt_about), img_label);
  gtk_widget_show(main_wnd.bt_about);
}

static void create_rules_list()
{
  //gchar *a_columns_titles[LIST_COLS] = {"Process ID", "Process Name", "User Name" ,"CPU","Mem Usage"};
  //gchar *a_columns_titles[LIST_COLS] = {"Process ID", "User Name" ,"CPU","Mem Usage","Process Name"};
  gchar *a_columns_titles[LIST_COLS] = {"Process ID", "Process Name", "User Name" ,"CPU", "Mem Usage"};
  
  main_wnd.scrolled_wnd_list = gtk_scrolled_window_new( NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(main_wnd.scrolled_wnd_list),
				 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_set_usize(main_wnd.scrolled_wnd_list, 700, 300);
  gtk_box_pack_start(GTK_BOX(main_wnd.bx_three), main_wnd.scrolled_wnd_list, 
		     TRUE, TRUE, 0);
  gtk_widget_show(main_wnd.scrolled_wnd_list);

  main_wnd.ls_rules = gtk_clist_new_with_titles(LIST_COLS, a_columns_titles);
  gtk_container_add(GTK_CONTAINER(main_wnd.scrolled_wnd_list), 
		    main_wnd.ls_rules);
  gtk_clist_set_column_width(GTK_CLIST(main_wnd.ls_rules), 0, 70);
  gtk_clist_set_column_width(GTK_CLIST(main_wnd.ls_rules), 1, 150);
  gtk_clist_set_column_width(GTK_CLIST(main_wnd.ls_rules), 2, 150);
  gtk_clist_set_column_width(GTK_CLIST(main_wnd.ls_rules), 3, 90);
  gtk_clist_set_column_width(GTK_CLIST(main_wnd.ls_rules), 4, 90);
  
  gtk_widget_show(main_wnd.ls_rules);
}

static void create_boxes()
{
  main_wnd.bx_one = gtk_vbox_new(FALSE, 15);
  main_wnd.bx_two = gtk_hbox_new(FALSE, 10);
  main_wnd.bx_three = gtk_hbox_new(FALSE, 0);
}
/*Refresh funtion*/

gboolean refreshValues(gpointer data)
{
	gint n_selected_index = -1;
	static gint n_old_index;
	//g_print("Refreshing values.......\n");
	n_selected_index = GTK_CLIST(main_wnd.ls_rules)->focus_row;
	update_rules();
/*
	if(n_selected_index >0 )
	{
		scroll_list_to(main_wnd.ls_rules, n_selected_index);
		//reset_selected_row(main_wnd.ls_rules,n_old_index, n_selected_index);
		//n_old_index = n_selected_index;
		//GTK_CLIST(main_wnd.ls_rules)->focus_row = n_selected_index;
	}
*/	return TRUE;
}

//ApplicationState aState = {};

int main(int argc, char *argv[])
{
  
  //ApplicationState aState = {};
  /* Pointer to the LibOSSO context object/connection (NEW). */
  //osso_context_t* ctx = NULL;
/*  if(!gnome_vfs_init()) 
  {
      g_error("Failed to initialize GnomeVFS-libraries, exiting\n");
  } 
  */gtk_init(&argc, &argv);

  /* Setup the HildonProgram, HildonWindow and application name. */
  main_wnd.aState.program = HILDON_PROGRAM(hildon_program_get_instance());
  //g_set_application_name("Task Manager");
  //main_wnd.aState.window = HILDON_WINDOW(hildon_window_new());
  //hildon_program_add_window(main_wnd.aState.program, HILDON_WINDOW(main_wnd.aState.window));
  /* Create a LibOSSO context (which will also attach this
   * application to the D-Bus (NEW).
   * NOTE:
   * We use the name and version from the configure.ac.
   * The D-Bus name is built by prefixing "org.maemo." to the
   * package name. */
  
    g_print("Initializing LibOSSO context Task Manager V 0.1 \n");
    /*ctx = osso_initialize("org.taskmanager", VERSION, TRUE, NULL);
    if (ctx == NULL) 
    {
	    g_print("Failed to init LibOSSO\n");
	    return EXIT_FAILURE;
    }*/
    g_print("LibOSSO Init done\n");


  main_wnd.aState.window = HILDON_WINDOW(hildon_window_new());
  hildon_program_add_window(main_wnd.aState.program, HILDON_WINDOW(main_wnd.aState.window));
  
  //aState.window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  //gtk_window_set_title (HILDON_WINDOW(main_wnd.aState.window), STR_APP_TITLE);
  gtk_window_set_policy(HILDON_WINDOW(main_wnd.aState.window), FALSE, TRUE, FALSE);
  gtk_signal_connect (GTK_OBJECT (main_wnd.aState.window), "delete_event",
		      GTK_SIGNAL_FUNC (on_delete_wnd_event), NULL);
  gtk_container_set_border_width (GTK_CONTAINER (main_wnd.aState.window), 10);

  GdkColor green = {0, 0x0000, 0xffff, 0x0000};
  GdkColor blue = {0, 0x3300, 0xbb00, 0xff00};

  gtk_widget_modify_bg(main_wnd.aState.window, GTK_STATE_NORMAL, &blue);
      
  create_boxes();
  
  main_wnd.frm_main = gtk_frame_new(" Task Manager ");

  gtk_container_add(GTK_CONTAINER (main_wnd.aState.window), main_wnd.bx_one);
  gtk_box_pack_end(GTK_BOX (main_wnd.bx_one), main_wnd.bx_two, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX (main_wnd.bx_one), main_wnd.frm_main, TRUE, TRUE, 0);
  gtk_container_add(GTK_CONTAINER(main_wnd.frm_main), main_wnd.bx_three);
  gtk_widget_set_usize(main_wnd.frm_main, 706, 300);
  gtk_widget_modify_bg(main_wnd.frm_main, GTK_STATE_NORMAL, &green);
  gtk_widget_show(main_wnd.frm_main);
/*
  PangoFontDesc *font_desc = pango_font_description_new ();
  pango_font_description_set_size (font_desc, 8);
  gtk_widget_modify_font (main_wnd.frm_main, font);
  gtk_widget_modify_font ( main_wnd.bx_two, font);
 // gtk_widget_modify_font (main_wnd.frm_main, font);
//  pango_font_description_free (font_desc);
     
  gtk_widget_show(main_wnd.frm_main);
*/	
  create_rules_list();
  create_kill_button();
  create_exit_button();
  create_about_button();
	
  update_rules();
  
  g_timeout_add(8000, refreshValues, NULL);

  gtk_widget_show(main_wnd.bx_two);
  gtk_widget_show(main_wnd.bx_three);
  gtk_widget_show (main_wnd.bx_one);  
  gtk_widget_show (main_wnd.aState.window);

  gtk_main();

  //pango_font_description_free (font_desc);
  g_print("main: returned from gtk_main & de-initing LibOSSO\n");
    /* De-initialize LibOSSO (detaches from the D-Bus) (NEW). */
  //osso_deinitialize(ctx);

  return 0;
}
void get_process(GtkWidget *);

/* some functions */
void update_rules()
{
  get_process(main_wnd.ls_rules);
}

/* 
 * this function executes the command for iptables
 * so we can get output and put it on the list.
 */
void get_process(GtkWidget *pls_rules)
{
	int n_cell = 0;
	int n_row = 0;
	int n_index = 0;
	int i;
	int n_col = 0;
	//char ch_tmp;
	//char s_str_buffer[64];
	//char s_popen_cmd[256];
	gchar *s_row_cells[5] = { NULL, NULL, NULL, NULL, NULL};
	
	system("/usr/bin/myps --no-headers -A k -pcpu -o \"pid,ucomm,uname,pcpu,size\" > /tmp/.tess");
	//system(" ps --no-headers -A -o \"pid,ucomm,uname,%cpu,sz\" > /tmp/.tess");
	//system("top -b -n 1 > /tmp/.tess");
    gint nlines=0;
//	g_print("Openning the file with name %s", filename);
    GIOChannel *in = g_io_channel_new_file(filename,"r",NULL);
    if(in == NULL)
		return NULL;

    gchar *contents;
    gsize length;
    gsize termpos;
    GIOStatus results;
//    GIOChannelError *error;

	gint taskpos=0;

	 gtk_clist_clear((GtkCList *) pls_rules);
	/* 
	 //read the first three lins here
	 for(i=0; i<LINES_SKIPPED; i++)
	 {
		results = g_io_channel_read_line(in,&contents,&length,&termpos,NULL);
		if((results == G_IO_STATUS_EOF)||(results == G_IO_STATUS_ERROR))
		{
			 g_print("Error reading the temporary file\n");
			 return;
		}
	 }
	*/ 
	results = g_io_channel_read_line(in,&contents,&length,&termpos,NULL);

	while((results != G_IO_STATUS_EOF)&&(results != G_IO_STATUS_ERROR))
    {
	  //read each line and store into the task array
      gint pos =0;
      contents[length-1]='\0';
      nlines++;
      gchar *temp = strtok(contents, " ");
      while(temp != NULL)
      {
//			s_row_cells[pos] = temp;
       	//	pos++;
			if (n_col == 0)
			{
				s_row_cells[pos] = temp;
				pos++;
				gtk_clist_insert((GtkCList *) pls_rules, n_row + 1, s_row_cells);
				n_cell++;
			}
			else
			{
				s_row_cells[pos-1] = temp;
				pos++;
				gtk_clist_set_text(GTK_CLIST (pls_rules), n_row, n_cell, temp);
				n_cell++;
			}
			
			n_col++;
							 
        	temp = strtok(NULL, " ");
      }
	  //Here add the code to insert into the Clist
      gtk_clist_set_text(GTK_CLIST (pls_rules), n_row, n_cell,
				                 left_trim(temp));
      n_index = 0;
      n_cell = 0;
      n_col = 0;
      n_row++;
	  
      taskpos++;
      results = g_io_channel_read_line(in,&contents,&length,&termpos,NULL);
   	 }
     //return nlines;

}

/* moves the file descriptor the specified amount of lines by n_lines */
void bypass_lines(FILE *p_file, int n_lines)
{
  char ch_aux;
  int n_line_counter = 0;
	
  while (n_line_counter < n_lines)
    {
      ch_aux = getc(p_file);
      if (ch_aux == ASCII_LF)
	n_line_counter++;
    }
}

/* Callbacks */
gint on_delete_wnd_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  gchar command[128];
  if(want_to_exit() == TRUE)
    {
  	strcpy(command, "rm -f /tmp/.tess");

  	/* execute command */
  	system(command);
  
      	gtk_main_quit();
      	return(FALSE);
    }

  return(TRUE);
}

void on_bt_exit_clicked(GtkWidget *widget, gpointer data)
{
 gchar command[128];
   if(want_to_exit() == TRUE)
   {
        strcpy(command, "rm -f /tmp/.tess");

        /* execute command */
        system(command);
	
      gtk_main_quit();
   }
}

void on_bt_about_clicked(GtkWidget *widget, gpointer data)
{
  message_box(HILDON_WINDOW(main_wnd.aState.window), 
	      STR_APP_TITLE"\n"
	      "email: mohammed.taqi@mars-india.com\n"
	      "web: www.mars-india.com\n"
	      "(c) 2009 Mars Telecom\n",
	      GTK_MESSAGE_INFO, GTK_BUTTONS_OK);
}

/* just in case is needed */
void on_ls_rules_select_row(GtkWidget *widget, gint row, gint column,
			 GdkEventButton *event, gpointer data)
{
  
}

void on_bt_kill_clicked(GtkWidget *widget, gpointer data)
{
  gchar command_line[128] = " ";
  //gchar buf[5];
  gchar buffer[32];
  int n_msg_response;
  int n_selected_index = -1;

  n_selected_index = get_list_selected_row(main_wnd.ls_rules, buffer);

  g_print("selected buffer %s\n",buffer);
  /* check that something this selected first */
  if (n_selected_index == -1)
    {
      message_box(HILDON_WINDOW(main_wnd.aState.window), "There's no process selected!",
		  GTK_MESSAGE_WARNING, GTK_BUTTONS_OK);
    
      return;
    }
  
  /* ask first */
  n_msg_response = message_box(HILDON_WINDOW(main_wnd.aState.window), 
			      "You are about to kill a process. Continue?",
			      GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO);

  if (n_msg_response != GTK_RESPONSE_YES)
    return;
  
  /* remove from control */
  gtk_clist_remove(GTK_CLIST(main_wnd.ls_rules), n_selected_index);
	
  /* kill the process */
  strcat(command_line, "kill -9 ");
  strcat(command_line, buffer);

  /* execute command */
  system(command_line);

  /* update list */
  update_rules();
}
