/*
 * Task Manager is Copyright (C) 2009 Mars Telecom
 * Author Mohammed Taqi Ahmed
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MAIN_H
#define MAIN_H

#include <gtk/gtk.h> 
#include <stdio.h>
#include <stdlib.h>    
#include <string.h>
#include <ctype.h>
/* Pull in the LibOSSO library declarations (NEW). */
#include <libosso.h>
#include <hildon/hildon-program.h>
#include <libgnomevfs/gnome-vfs.h>
#include <gconf/gconf-client.h>

#include "tm_util.h"

#define STR_APP_TITLE   "Task Manager V.0.1"

#define LIST_COLS	5

#define ASCII_LF	0x0A
#define ASCII_CR	0x0D
#define ASCII_NUL	0x00
#define ASCII_SPACE	0x20

#define CREATE_INSERT 1
#define CREATE_ADD    2

extern void create_win(int n_op, int n_number);

/* functions */
void update_rules();
void get_rules(GtkWidget *pls_rules);
void bypass_lines(FILE *p_file, int n_lines);

/* callbacks */
gint on_delete_wnd_event(GtkWidget *widget, GdkEvent *event, gpointer data);
void on_bt_exit_clicked(GtkWidget *widget, gpointer data);
void on_bt_about_clicked(GtkWidget *widget, gpointer data);
void on_bt_kill_clicked(GtkWidget *widget, gpointer data);
void on_cb_tables_changed(GtkWidget *widget, gpointer data);

#endif /* MAIN_H */
